import * as z from './base';
import { ZodUndefined } from './undefined';
import { ZodNull } from './null';
import { ZodUnion } from './union';
import { ZodLiteral } from './literal';
export declare type ArrayKeys = keyof any[];
export declare type Indices<T> = Exclude<keyof T, ArrayKeys>;
declare type EnumValues = [ZodLiteral<string>, ...ZodLiteral<string>[]];
declare type StringValues<T extends EnumValues> = {
    [k in Indices<T>]: T[k] extends ZodLiteral<infer U> ? (U extends string ? U : never) : never;
}[Indices<T>];
export interface ZodEnumDef<T extends EnumValues = EnumValues> extends z.ZodTypeDef {
    t: z.ZodTypes.enum;
    values: T;
}
export declare class ZodEnum<T extends EnumValues = EnumValues> extends z.ZodType<T[number]['_type'], ZodEnumDef<T>> {
    optional: () => ZodUnion<[this, ZodUndefined]>;
    nullable: () => ZodUnion<[this, ZodNull]>;
    toJSON: () => ZodEnumDef<T>;
    get Values(): {
        [k in StringValues<T>]: k;
    };
    static create: <T_1 extends EnumValues>(values: T_1) => ZodEnum<T_1>;
}
export {};
