import * as z from './base';
import { ZodUndefined } from './undefined';
import { ZodNull } from './null';
import { ZodUnion } from './union';
declare type LiteralValue = string | number | boolean | undefined | null;
export interface ZodLiteralDef<T extends LiteralValue = LiteralValue> extends z.ZodTypeDef {
    t: z.ZodTypes.literal;
    value: T;
}
export declare class ZodLiteral<T extends LiteralValue> extends z.ZodType<T, ZodLiteralDef<T>> {
    optional: () => ZodUnion<[this, ZodUndefined]>;
    nullable: () => ZodUnion<[this, ZodNull]>;
    toJSON: () => ZodLiteralDef<T>;
    static create: <T_1 extends LiteralValue>(value: T_1) => ZodLiteral<T_1>;
}
export {};
